'use strict'

var Couchbase = require('couchbase');
var async = require('async');


var host = 'localhost';
var bucket = '<bucket>';

var constring = 'couchbase://' + host;
var couchbase = new Couchbase.Cluster(constring);

if (process.argv[2]) {
   bucket = process.argv[2];
}

function init(conn, item, callback) {
   conn.upsert(item.id, item.doc, (err, res) => {
      if (err) console.error('err upsert:', err);
      callback(err, res);
   });
}

function getAndLock(conn, item, callback) {
   conn.getAndLock(item.id, (err, res) => {
      if (err) console.error('err getAndLock:', err);
      else console.log('cas:', res.cas);
      callback(err, res);
   });
}


function main() {
   var conn;

   async.series([

      function connect(callback) {
         console.log('Connecting...');

         conn = couchbase.openBucket(bucket, (err) => {
            if (err) console.log('err:', err);
            callback(err);
         });
      },

      function execute(callback) {

         var item = {
            id: 'getAndLockTest',
            doc: {"foo": "bar"}
         };

         async.series([
            function _init(callback) {
               init(conn, item, callback);
            },
            function _first(callback) {
               console.log('> first');
               getAndLock(conn, item, callback);
            },
            function _second(callback) {
               console.log('> second');
               // And here is where we get the exception:  'Temporary failure received from server. Try again later'
               // code: 11
               getAndLock(conn, item, callback);
            },
               function _never(callback) {
                  console.log('This part will never run');
               }
            ], function (err) {
               callback(err, conn);
            }
         );
      },

      ], 
      function (err, res) {
         console.log('Disconnecting...');
         conn.disconnect();
         console.log ('bye');
      }
   );

}
main();